UnloadModeEvent = {};
UnloadModeEvent_mt = Class(UnloadModeEvent, Event);

InitEventClass(UnloadModeEvent, "UnloadModeEvent");

function UnloadModeEvent:emptyNew()
    local self = Event:new(UnloadModeEvent_mt);
    self.className="UnloadModeEvent";
    return self;
end;

function UnloadModeEvent:new(vehicle, state)
    local self = UnloadModeEvent:emptyNew()
    self.vehicle = vehicle;
	self.state = state;
    return self;
end;

function UnloadModeEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.state = streamReadBool(streamId);
    self.vehicle = networkGetObject(id);
    self:run(connection);
end;

function UnloadModeEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteBool(streamId, self.state);
end;

function UnloadModeEvent:run(connection)   
	self.vehicle:UnloadMode(self.state, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(UnloadModeEvent:new(self.vehicle, self.state), nil, connection, self.vehicle);
    end;
end;

function UnloadModeEvent.sendEvent(vehicle, state, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(UnloadModeEvent:new(vehicle, state), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(UnloadModeEvent:new(vehicle, state));
		end;
	end;
end;